\documentclass[../t19_ME401_Midterm.tex]{subfiles}
\begin{document}
\section{Explanation of Subsystems}\label{sec:subsys}

\subsection{Robot Images}\label{subsec:rbotPics}
\begin{figure}[htbp]
    \centering
    \begin{subfigure}{0.32\textwidth}
        \centering
        \includegraphics[width=\textwidth]{Images/robotFL.jpeg}
        \caption{}
        \label{subfig:robotFL}
    \end{subfigure}
    \begin{subfigure}{0.32\textwidth}
        \centering
        \includegraphics[width=\textwidth]{Images/robotFR.jpeg}
        \caption{}
        \label{subfig:robotFR}
    \end{subfigure}
    \begin{subfigure}{0.32\textwidth}
        \centering
        \includegraphics[width=\textwidth]{Images/robotIRsens.jpeg}
        \caption{}
        \label{subfig:robotIR}
    \end{subfigure}

    \vfill
    
    \begin{subfigure}{0.32\textwidth}
        \centering
        \includegraphics[width=\textwidth]{Images/robotTop.jpeg}
        \caption{}
        \label{subfig:robotTop}
    \end{subfigure}
    \begin{subfigure}{0.32\textwidth}
        \centering
        \includegraphics[width=\textwidth]{Images/robotBottom.jpeg}
        \caption{}
        \label{subfig:robotBottom}
    \end{subfigure}
       
    \caption[Robot Images]{\figref{subfig:robotFL} and \figref{subfig:robotFR} respectively show the front left and front right of our robot. We see the ball capture mechanism at the front of the robot, with the limit switches used to determine when to turn around on either side of the entrance to the capture area. \figref{subfig:robotIR} shows the distance sensors used to find target distance and when a ball gets captured. \figref{subfig:robotTop} and \figref{subfig:robotBottom} respectively show the top and bottom of our robot.}
    \label{fig:robotPics}
\end{figure}

\subsection{PID Controller}\label{subsec:PID}
In order for the DC motor to act and rotate how we wanted it to, we had to implement a PID controller. This controller was used to accurately and precisely control the motor.

We tuned the PID controller using the Ziegler-Nichols method, which involves adjusting a PID controller with only a proportional gain until the system perfectly oscillates in response to a step input. Once we found the proportional gain, Ku, that resulted in perfect oscillation, we would use that Ku value along with the period of the oscillation, Tu, to define the gain values Kp, Kd, and Ki that we would use to control our motor.

\begin{figure}
    \begin{subfigure}{0.49\textwidth}
        \centering
        \includegraphics[width=\textwidth]{Images/PIDresponse.png}
        \caption[PID Response]{Response curve for DC motor PID controller}
        \label{fig:PIDresponse}
    \end{subfigure}
    \begin{subfigure}{0.49\textwidth}
        \centering
        \includegraphics[width=\textwidth]{Images/PIDoscillate.png}
        \caption[PID Free Oscillation]{PID tuning process, finding ultimate     $K_p$ value. }
    \end{subfigure}
    \caption{PID tuning data}
    \label{fig:PIDTuning}
\end{figure}

This controller can be seen in \apref{ap:PID}.


\subsection{IR Distance Sensor}\label{subsec:IRsensor}
While in the zombie state, an IR distance sensor is used to find nearby targets to turn into zombies. The distance sensor that we use takes readings in analog values that need to be converted to a distance to be used for the rest of our code. We calibrate the sensor by taking readings at different distances and creating a curve fit.

\begin{figure}[htbp]
    \centering
    \includegraphics[width=0.7\textwidth]{Images/irCal.png}
    \caption[IR Sensor Calibration]{Calibration curve for IR distance sensor used for target finding}
    \label{fig:IRcal}
\end{figure}

Due to the nature of the IR sensor, we will get values that are wildly different than the actual reading. To offset this error, a median filter is used to negate the effect of any outliers. We use a filter size of 7, which means we will take 7 distance readings, reporting the median back whenever the distance sensor function is called.

\subsection{Wheel Servo Control}\label{subsec:servo}

When controlling the servos that drive the robot, they had to be set up a little differently depending on what state our robot was in. The function used to make the wheels turn was the same. This function can be found at line 349 of the code in \apref{ap:mainFunc}. This function only tells the servos how fast to spin the wheels. However, finding how fast each wheel had to be spun is different depending on what state the robot is in.

\subsubsection{Healthy and Healing State}

In these states the robot is able to use the camera information. So, to find the out how to spin the wheels first the robot calls the find closest function from line 215, \apref{ap:mainFunc}. This function will find both the closest Zombie and the closest ball. After those have been found both states then call the drive\_to function from line 287, \apref{ap:mainFunc}. This function takes in the position of Zombie or the ball and then finds the angel between our robot and the position passed into the function. Then depending on that angle will determine how fast our robot will turn to face ether toward the ball/Zombie or away from the Zombie.

\subsubsection{Zombie State }

In this state the robot has to the IR distance sensor to gather information on the other robots on the field. In the Zombie state the robot will first call the zFindTarget function (Line 175, \apref{ap:mainFunc}). This function gives the minimum distance to the closest robot, and the minimum angle to that robot. Then the Zombie state calls the zDriveTo function (Line 194, \apref{ap:mainFunc}). This function takes in the minimum angle of the closest robot and depending on how big that angle is (and this angle is relative to the center of the robot) will determine how fast our robot will turn to chase the sited robot.

\subsection{Ball Capture Mechanism}\label{subsec:ballCapture}

The way that the ball gets captured with the front bumper of the robot. This bumper was created with a wide mouth that slants outward from the robot itself. The face of the bumper had a small opening in the middle of it. The sides of the face were slanted in toward the opening in the face of the bumper so the ball would be able to easily roll into the bumper. The reason that the sides of the bumper slant out and away from the bumper and that the sides of the face slant in toward the middle, was so that once the ball is captured it can be held in the bumper without the need of a door. Also, to show that a ball has been captured on top of the bumper there will be a distance sensor that faces inside of the bumper and when it sees a ball it will light up an LED light.

\subsection{Wall Avoidance}\label{subsec:avoidance}

In order to keep our robot from getting stuck up against a wall we attached a limit switch to each side of the front bumper. This is because our robot is always driving forward unless it needs to back away from a wall.

Depending on what button is pushed will determine oh the robot will behave when avoiding the wall.

\begin{itemize}
    \item If the Left-side button is pushed the robot will back up to the left.
    \item If the Right-side button is pushed the robot will back up to the right.
    \item If both buttons are pushed at the same time the robot will also back up to the right. This was done to help keep the code simpler.
\end{itemize}

\clearpage
\subsection{Wiring Diagram}\label{subsec:wiring}

\begin{figure}[htbp]
    \centering
    \includegraphics[width=0.7\textwidth]{Images/wiringDia.png}
    \caption[Wiring Diagram]{Wiring diagram for robot}
    \label{fig:wiring}
\end{figure}





\end{document}